Bug 116916 - tg3 driver doesn't support bonding driver's ALB mode
tg3 driver doesn't support bonding driver's ALB mode
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
3.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Miller
Brian Brock
tg3
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-02-26 08:30 EST by Martin Wilck
Modified: 2010-10-21 22:32 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-05-11 21:08:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
fix for MAC setting bug (702 bytes, patch)
2004-03-08 14:09 EST, David Miller
no flags Details | Diff

  None (edit)
Description Martin Wilck 2004-02-26 08:30:22 EST
Description of problem:

It is impossible to use the adaptive load balancing (ALB) mode of the
Linux bonding driver with the tg3 base driver because the tg3 driver
doesn't support changing the MAC address of a running interface.

Version-Release number of selected component (if applicable):
2.4.21-9.EL and earlier

How reproducible:
always

Steps to Reproduce:
1.install system with Broadcom NIC and tg3
2.configure bonding driver with mode=6 using the Broadcom NIC
  
Actual results: the following error message:

bonding: Error: alb_set_mac_addr: dev->set_mac_address of dev eth0
failed! ALB mode requires that the base driver support setting the hw
address also when the network device's interface is open

Expected results:

ALB mode works.

Additional info:

Works with Broadcomn's bcm5700 driver, thus it is no Hardware problem

The following lines in tg3_set_mac_addr()  (tg3.c line 4523f.) seem to
be responsible:

        if (netif_running(dev))
                return -EBUSY;
Comment 2 David Miller 2004-03-08 14:08:54 EST
Yes, that test is not needed at all, the fix is to simply remove
those two lines.
Comment 3 David Miller 2004-03-08 14:09:27 EST
Created attachment 98376 [details]
fix for MAC setting bug
Comment 4 Martin Wilck 2004-03-09 03:26:34 EST
Great, thanks.
Comment 7 Martin Wilck 2004-04-06 08:54:23 EDT
When will this part become part of an official RHEL kernel?
Comment 8 Ernie Petrides 2004-04-07 22:39:38 EDT
The tg3 driver has just been upgraded to v3.1 in tonight's
respin of RHEL3 U2 (kernel version 2.4.21-13.EL) to address
this problem.
Comment 9 John Flanagan 2004-05-11 21:08:36 EDT
An errata has been issued which should help the problem described in this bug report. 
This report is therefore being closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, please follow the link below. You may reopen 
this bug report if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2004-188.html

Note You need to log in before you can comment on or make changes to this bug.